# coding: utf-8

"""
    Control-M Services

    Provides access to BMC Control-M Services  # noqa: E501

    OpenAPI spec version: 9.20.215
    Contact: customer_support@bmc.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from clients.ctm_api_client.configuration import Configuration


class MFTFolderProjectionData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "name": "str",
        "authorized_internal_users": "list[str]",
        "authorized_external_users_and_groups": "list[str]",
        "access_type": "str",
    }

    attribute_map = {
        "name": "name",
        "authorized_internal_users": "authorizedInternalUsers",
        "authorized_external_users_and_groups": "authorizedExternalUsersAndGroups",
        "access_type": "accessType",
    }

    def __init__(
        self,
        name=None,
        authorized_internal_users=None,
        authorized_external_users_and_groups=None,
        access_type=None,
        _configuration=None,
    ):  # noqa: E501
        """MFTFolderProjectionData - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._name = None
        self._authorized_internal_users = None
        self._authorized_external_users_and_groups = None
        self._access_type = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if authorized_internal_users is not None:
            self.authorized_internal_users = authorized_internal_users
        if authorized_external_users_and_groups is not None:
            self.authorized_external_users_and_groups = (
                authorized_external_users_and_groups
            )
        if access_type is not None:
            self.access_type = access_type

    @property
    def name(self):
        """Gets the name of this MFTFolderProjectionData.  # noqa: E501

        The name of the folder  # noqa: E501

        :return: The name of this MFTFolderProjectionData.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this MFTFolderProjectionData.

        The name of the folder  # noqa: E501

        :param name: The name of this MFTFolderProjectionData.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def authorized_internal_users(self):
        """Gets the authorized_internal_users of this MFTFolderProjectionData.  # noqa: E501

        Authorized Internal Users  # noqa: E501

        :return: The authorized_internal_users of this MFTFolderProjectionData.  # noqa: E501
        :rtype: list[str]
        """
        return self._authorized_internal_users

    @authorized_internal_users.setter
    def authorized_internal_users(self, authorized_internal_users):
        """Sets the authorized_internal_users of this MFTFolderProjectionData.

        Authorized Internal Users  # noqa: E501

        :param authorized_internal_users: The authorized_internal_users of this MFTFolderProjectionData.  # noqa: E501
        :type: list[str]
        """

        self._authorized_internal_users = authorized_internal_users

    @property
    def authorized_external_users_and_groups(self):
        """Gets the authorized_external_users_and_groups of this MFTFolderProjectionData.  # noqa: E501

        Authorized External Users And User Groups  # noqa: E501

        :return: The authorized_external_users_and_groups of this MFTFolderProjectionData.  # noqa: E501
        :rtype: list[str]
        """
        return self._authorized_external_users_and_groups

    @authorized_external_users_and_groups.setter
    def authorized_external_users_and_groups(
        self, authorized_external_users_and_groups
    ):
        """Sets the authorized_external_users_and_groups of this MFTFolderProjectionData.

        Authorized External Users And User Groups  # noqa: E501

        :param authorized_external_users_and_groups: The authorized_external_users_and_groups of this MFTFolderProjectionData.  # noqa: E501
        :type: list[str]
        """

        self._authorized_external_users_and_groups = (
            authorized_external_users_and_groups
        )

    @property
    def access_type(self):
        """Gets the access_type of this MFTFolderProjectionData.  # noqa: E501

        Folder's access type (Limited, Unlimited).  # noqa: E501

        :return: The access_type of this MFTFolderProjectionData.  # noqa: E501
        :rtype: str
        """
        return self._access_type

    @access_type.setter
    def access_type(self, access_type):
        """Sets the access_type of this MFTFolderProjectionData.

        Folder's access type (Limited, Unlimited).  # noqa: E501

        :param access_type: The access_type of this MFTFolderProjectionData.  # noqa: E501
        :type: str
        """

        self._access_type = access_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(MFTFolderProjectionData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MFTFolderProjectionData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MFTFolderProjectionData):
            return True

        return self.to_dict() != other.to_dict()
